<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers:username,password,destination");
include("conn.php");
include("functions.php");
$response = array();
$response["status"] = false;
$response["message"] = "Un Authorized";
$headers = getallheaders();
$myUserName = mysqli_real_escape_string($conn,$headers["username"]);
$myPassword =   mysqli_real_escape_string($conn,$headers["password"]);
$type = $_GET["type"];
if($type=="vehiclesetupjoiningfee"){
	$amount = trim($_POST["amount"]);
	if(is_numeric($amount)){
		$sql= "UPDATE `vehiclesetup` SET `JoiningFee`=?";
		$values = array($amount);
		if(pdoExecute($sql, $values)){
			$response["status"] = true;
			$response["message"] = "The joining fee was successfully updated";
		}else{
			$response["status"] = false;
			$response["message"] = "The joining fee could not be updated. Please try again later";
		}
	}else{
		$response["status"] = false;
		$response["message"] = "Please specify a valid value for joining fee";
	}
}
else if($type=="vehiclesetupdailyfee"){
	$amount = trim($_POST["amount"]);
	if(is_numeric($amount)){
		$sql= "UPDATE `vehiclesetup` SET `DailyFee`=?";
		$values = array($amount);
		if(pdoExecute($sql, $values)){
			$response["status"] = true;
			$response["message"] = "The daily fee was successfully updated";
		}else{
			$response["status"] = false;
			$response["message"] = "The daily fee could not be updated. Please try again later";
		}
	}else{
		$response["status"] = false;
		$response["message"] = "Please specify a valid value for daily fee";
	}
}
else if($type=="vehiclesetupmonthlyfee"){
	$amount = trim($_POST["amount"]);
	if(is_numeric($amount)){
		$sql= "UPDATE `vehiclesetup` SET `MonthlyFee`=?";
		$values = array($amount);
		if(pdoExecute($sql, $values)){
			$response["status"] = true;
			$response["message"] = "The monthly fee was successfully updated";
		}else{
			$response["status"] = false;
			$response["message"] = "The monthly fee could not be updated. Please try again later";
		}
	}else{
		$response["status"] = false;
		$response["message"] = "Please specify a valid value for monthly fee";
	}
}else if($type=="vehiclesetupnoobjectionfee"){
	$amount = trim($_POST["amount"]);
	if(is_numeric($amount)){
		$sql= "UPDATE `vehiclesetup` SET `NoObjectionFee`=?";
		$values = array($amount);
		if(pdoExecute($sql, $values)){
			$response["status"] = true;
			$response["message"] = "The no objection fee was successfully updated";
		}else{
			$response["status"] = false;
			$response["message"] = "The no objection fee could not be updated. Please try again later";
		}
	}else{
		$response["status"] = false;
		$response["message"] = "Please specify a valid value for monthly fee";
	}
}
else if($type=="membersetupjoiningfee"){
	$amount = trim($_POST["amount"]);
	if(is_numeric($amount)){
		$sql= "UPDATE `membersetup` SET `JoiningFee`=?";
		$values = array($amount);
		if(pdoExecute($sql, $values)){
			$response["status"] = true;
			$response["message"] = "The joining fee was successfully updated";
		}else{
			$response["status"] = false;
			$response["message"] = "The joining fee could not be updated. Please try again later";
		}
	}else{
		$response["status"] = false;
		$response["message"] = "Please specify a valid value for joining fee";
	}
}
else if($type=="membersetupdailyfee"){
	$amount = trim($_POST["amount"]);
	if(is_numeric($amount)){
		$sql= "UPDATE `membersetup` SET `DailyFee`=?";
		$values = array($amount);
		if(pdoExecute($sql, $values)){
			$response["status"] = true;
			$response["message"] = "The daily fee was successfully updated";
		}else{
			$response["status"] = false;
			$response["message"] = "The daily fee could not be updated. Please try again later";
		}
	}else{
		$response["status"] = false;
		$response["message"] = "Please specify a valid value for daily fee";
	}
}
else if($type=="membersetupmonthlyfee"){
	$amount = trim($_POST["amount"]);
	if(is_numeric($amount)){
		$sql= "UPDATE `membersetup` SET `MonthlyFee`=?";
		$values = array($amount);
		if(pdoExecute($sql, $values)){
			$response["status"] = true;
			$response["message"] = "The monthly fee was successfully updated";
		}else{
			$response["status"] = false;
			$response["message"] = "The monthly fee could not be updated. Please try again later";
		}
	}else{
		$response["status"] = false;
		$response["message"] = "Please specify a valid value for monthly fee";
	}
}else if($type=="savingswithdrawalcharge"){
	$amount = trim($_POST["amount"]);
	if(is_numeric($amount)){
		$sql= "UPDATE `membersetup` SET `savingswithdrawalcharge`=?";
		$values = array($amount);
		if(pdoExecute($sql, $values)){
			$response["status"] = true;
			$response["message"] = "The Savings Withdrawal Charge was successfully updated";
		}else{
			$response["status"] = false;
			$response["message"] = "The Savings Withdrawal Charge could not be updated. Please try again later";
		}
	}else{
		$response["status"] = false;
		$response["message"] = "Please specify a valid value for Savings Withdrawal Charge";
	}
}
else if($type=="customerreceipts"){
	
}
else if($type=="pettycashvoucher"){
	if(isset($_POST["pcvNo"])){
	    // 
		$pcvNo = trim($_POST["pcvNo"]);
		$region = trim($_POST["region"]);
		$salesRep = trim($_POST["salesRep"]);
		
		$bankCode = trim($_POST["bankCode"]);
		$pcvDate = trim($_POST["pcvDate"]);
		$refNo = trim($_POST["refNo"]);
		$payee = trim($_POST["payee"]);
		
		//check exists
		$tPcvNo = mysqli_real_escape_string($conn, $pcvNo);
		$check = "SELECT * FROM `pettycashvouchers` where pcvNo = '$tPcvNo'";
		$checkRes = mysqli_query($conn, $check);
		if(mysqli_num_rows($checkRes)>0){ //exists, update
		$sql = "UPDATE `pettycashvouchers` SET `regionCode`=?,`salesRep`=?,`bank`=?,`externalRef`=?, `pcvDate`= ?,`payee`=? WHERE `pcvNo` = ? and `posted` = 0";
		$values = array($region,$salesRep,$bankCode,$refNo,$pcvDate,$payee,$pcvNo);
			if(pdoExecute($sql, $values)){
				$response["status"] = true;
				$response["message"] = "The petty cash voucher was successfully updated";
			}else{
				$response["status"] = false;
				$response["message"] = "The petty cash voucher could not be updated";
			}
			
		}else{//insert
			$sql = "INSERT INTO `pettycashvouchers`(`pcvNo`,`regionCode`,`salesRep`, `bank`, `pcvDate`, `externalRef`,`payee`,`posted`, `createdOn`, `createdBy`) VALUES (?,?,?,?,?,?,?,0,NOW(),?)";
			$values = array($pcvNo,$region,$salesRep,$bankCode,$pcvDate, $refNo,$payee,$myUserName);
			if(pdoExecute($sql, $values)){
				$response["status"] = true;
				$response["message"] = "The petty cash voucher was successfully created";
				$response["overLoad1"] = $pcvNo;
				$getDate = "select * from pettycashvouchers where pcvNo = '$tPcvNo'";
				$dateRes = mysqli_query($conn, $getDate);
				while($dateDetails = mysqli_fetch_assoc($dateRes)){
					$myDate = explode(" ",$dateDetails["createdOn"] );
					$response["overLoad2"] =$myDate[0];
				}
				
			}else{
				$response["status"] = false;
				$response["message"] = "The petty cash voucher could not be created";
			}
		}
	}
}
else if($type=="pcvlines"){
	$code = trim($_POST["code"]);
	$amount = trim($_POST["amount"]);
	$pcvNo = trim($_POST["pcvNo"]);
	$tPcvNo = mysqli_real_escape_string($conn,$pcvNo);
	$checkSql = "SELECT * FROM `pettycashvouchers` where pcvNo  ='$tPcvNo' and posted = 0";
	$checkRes = mysqli_query($conn, $checkSql);
	if(mysqli_num_rows($checkRes)>0){
		$sql = "UPDATE `pettycashvoucherlines` SET `amount` = ? WHERE id = ? and pcvNo = ?";
		$values = array($amount,$code,$pcvNo);
		if(pdoExecute($sql, $values)){
			$response["status"] = true;
			$response["message"] = "The line was successfully updated";
		}else{
			$response["status"] = false;
			$response["message"] = "The line could not be updated";
		}
	}else{
		$response["status"] = false;
		$response["message"] = "A petty cash voucher with the given no does not exist \n or has already been posted";
	}
}
else if($type=="updateuser"){
	$userName = trim($_POST["userName"]);
	$fullName = trim($_POST["fullName"]);
	$emailAddress = trim($_POST["emailAddress"]);
	$phoneNumber = trim($_POST["phoneNumber"]);
	$password = trim($_POST["password"]);
	//username is required
	//username atleast 4 characters
	//full name is required
	//password is required
	//password minimum 4 characters
	$error = false;
	$message = "";
	if($userName==""){
		$message = "Username is required";
		$error = true;
	}
	if(strlen($userName)<4){
		$message.= strlen($message)>0?"\n":"";
		$message .= "Username must be atleast 4 characters";
		$error = true;
	}
	if($fullName==""){
		$message.= strlen($message)>0?"\n":"";
		$message .= "Fullname is required";
		$error = true;
	}
	if($password==""){
		$message = "Password is required";
		$error = true;
	}
	if(strlen($password)<4){
		$message.= strlen($message)>0?"\n":"";
		$message .= "Password must be atleast 4 characters";
		$error = true;
	}
	if($error){
		$response["status"] = false;
		$response["message"] =$message;
	}else{
		//update
		$password = hash("sha256", $password);
		$sql = "UPDATE `users` SET `fullname` = ?, `email` = ?, `phone`=?,`Password`=? where username = ?";
		$values = array($fullName,$emailAddress,$phoneNumber,$password,$userName);
		if(pdoExecute($sql, $values)){			
			$response["status"] = true;
			$response["message"] = "The User was successfully Updated";
		}else{			
			$response["status"] = false;
			$response["message"] = "The User could not be Updated";
		}
	}
}
else if ($type=="appForgotPassword"){
    $idNo = "";
    $emailAddress = "";
    $error = false;
    $message = "";
    if(isset($_POST["idNo"])){
        $idNo = trim($_POST["idNo"]);
    }else{
        $error = false;
        $message = "Please include all required fields";
    }
    if(isset($_POST["emailAddress"])){
        $emailAddress = trim($_POST["emailAddress"]);
    }else{
        $error = false;
        $message = "Please include all required fields";
    }
    if(!$error){
        if(strlen($idNo)<6){
            $error = false;
            $message = "Please provide a valid Id No";
        }
        if(strlen($emailAddress)<6){
            $error = false;
            $message = "Please provide a valid email address";
        }
    }
    if($error){
        $response["status"] = false;
	    $response["message"] = $message;
    }else{
        $idNo = mysqli_real_escape_string($conn, $idNo);
        $emailAddress = mysqli_real_escape_string($conn, $emailAddress);
        //check registered users
        $sql = "SELECT * FROM `mobileappusers` WHERE idNo='$idNo' and emailAddress='$emailAddress'";
        $res = mysqli_query($conn,$sql);
        $records = mysqli_num_rows($res);
        if($records==1){
            while($result=mysqli_fetch_assoc($res)){
                $phoneNumber = $result["phoneNumber"];
                $password = rand(1000,9999);
                $textMessage="Dear ".$result["userType"].", We have received your password reset request. Please use the password $password to login";
                $encPass = hash("sha256",$password);
                $update = "update mobileappusers set password= ?, changePassword=? where idNo=? and emailAddress=?";
                $values = array($encPass,1,$idNo,$emailAddress);
                if(pdoExecute($update,$values)){
                    sendTextMessage($phoneNumber, $textMessage);
                    $response["status"] = true;
	                $response["message"] = "We have sent a one time password to your phone number. Please use it to login to your account";
                }else{
                    	$response["status"] = false;
	                    $response["message"] = "Your password could not be updated. Please try again later";
                }
            }
            
        }else{
            //no record, try first time registration
            // $sql = "SELECT COUNT(MemberNo) noOfClients,
            // (select COUNT(vendorNumber) from vendors WHERE idNo='$idNo' and email='$emailAddress' and vendortype='Investor') noOfInvestors,
            // (select COUNT(vendorNumber) from vendors WHERE idNo='$idNo' and email='$emailAddress' and vendortype='Sales Rep') noOfSalesRep 
            // FROM members WHERE IdNo= '$idNo' and Email = '$emailAddress' ";
            
            $sql = "SELECT COUNT(`customerNumber`) noOfClients,
                (SELECT COUNT(`vendorNumber`) FROM `vendors` WHERE `idNo`='$idNo' AND `email`='$emailAddress' AND `vendortype`='Sales Rep') noOfSalesRep 
                FROM `customers` WHERE `IdNo`= '$idNo' AND `Email` = '$emailAddress' ";
            
            $res = mysqli_query($conn,$sql);
            while($result = mysqli_fetch_assoc($res)){
                $error = false;
                $message="";
                $noOfClients = $result["noOfClients"];
                $noOfInvestors = $result["noOfInvestors"];
                $noOfSalesRep = $result["noOfSalesRep"];
                $accountType = "";//'Investor', 'Client', 'Sales Rep'
               
                $phoneNumber = "";
                $phoneSql="";
                if($noOfClients==1){
                    $phoneSql = "select * FROM `customers` WHERE IdNo= '$idNo' and Email = '$emailAddress'";
                    $accountType="Client";
                }else if($noOfSalesRep==1){
                    $phoneSql = "select * from vendors WHERE idNo='$idNo' and email='$emailAddress' and vendortype='Sales Rep'";
                    $accountType="Sales Rep";
                }else{
                    $error = true;
                    $message="An account with the selected credentials does not exist. Please contact support";
                }
                if($error){
                   $response["status"] = false;
	               $response["message"] = $message; 
                }else{
                    $accountNo = "";
                    $firstName = "";
                    $middleName = "";
                    $lastName = "";
                    $phoneRes = mysqli_query($conn,$phoneSql);
                    while($phoneResult = mysqli_fetch_assoc($phoneRes)){
                       // print_r($phoneResult);
                        $phoneNumber = $phoneResult["phoneNumber"];
                        $accountNo = $accountType == "Client" ? $phoneResult["customerNumber"] : $phoneResult["vendorNumber"];
                        $firstName = $phoneResult["firstName"];
                        $middleName = $phoneResult["middleName"];
                        $lastName = $phoneResult["lastName"];
                    }
                    $fullName = $firstName . $middleName . $lastName;
                    $password = rand(1000,9999);
                    $textMessage="Dear $accountType, We have received your account creation request. Please use the password $password to login";
                    $encPass = hash("sha256",$password);
                    $sql = "INSERT INTO `mobileappusers`(`idNo`, `emailAddress`, `userName`, `fullName`, `phoneNumber`, `accountNo`,`userType`, `password`, `createdOn`, `changePassword`) 
                        VALUES (?,?,?,?,?,?,?,?,NOW() + INTERVAL 7 HOUR,1)";
                    $values = array($idNo,$emailAddress,$idNo,$fullName,$phoneNumber,$accountNo,$accountType,$encPass);
                    if(pdoExecute($sql,$values)){
                        sendTextMessage($phoneNumber, $textMessage);
                        $response["status"] = true;
    	                $response["message"] = "We have sent a one time password to your phone number. Please use it to login to your account";
                    }else{
                        	$response["status"] = false;
    	                    $response["message"] = "Your Account could not be created. Please try again later";
                    }
                    
                }
                
            }
        }
    }
}
else if ($type=="appUpdatePassword"){
    //if ($_SERVER['REQUEST_METHOD']=='POST') {
    if(isset($_POST["accountNo"])&&isset($_POST["currentPassword"])&&isset($_POST["newPassword"])&&isset($_POST["confirmNewPassword"]))
    $accountNo = trim($_POST["accountNo"]);
    $tAccountNo = mysqli_real_escape_string($conn, $accountNo);
    $currentPassword =trim($_POST["currentPassword"]);
    $newPassword =trim($_POST["newPassword"]);
    $confirmNewPassword = trim($_POST["confirmNewPassword"]);
    if($newPassword==$confirmNewPassword){
        if(strlen($newPassword)<4){
            $response["status"] =0;
            $response["message"] ="Your new password must be atleast four(4) characters";
        }/*else if(!preg_match("#[a-z]+#",$newPassword)){
            $response["status"] =0;
            $response["message"] ="Your new password must contain at least one lower case";
        }else if(!preg_match("#[A-Z]+#",$newPassword)){
            $response["status"] =0;
            $response["message"] ="Your new password must contain at least one upper case";
        }else if(!preg_match("#[A-Z]+#",$newPassword)){
            $response["status"] =0;
            $response["message"] ="Your new password must contain at least one upper case";
        }else if(!preg_match("#[0-9]+#",$newPassword)){
            $response["status"] =0;
            $response["message"] ="Your new password must contain at least one digit";
        }else if(!preg_match("/[\'^£$%&*()}{@#~?><>,|=_+!-]/",$newPassword)){
            $response["status"] =0;
            $response["message"] ="Your new password must contain at least one special character";
        }*/else{
            $encrypredCurrentPassword = hash("sha256",$currentPassword);
            $check = "select * from mobileappusers where accountNo ='$tAccountNo' and password = '$encrypredCurrentPassword'";
            $checkRes = mysqli_query($conn, $check);
            $checkNum = mysqli_num_rows($checkRes);
            if($checkNum==1){
                $update = "update mobileappusers set password=?, changePassword=? where accountNo=?";
                $encryptedNewPassword = hash("sha256",$newPassword);
                $values = array($encryptedNewPassword,0,$accountNo);
                if(pdoExecute($update, $values)){
                    $response["status"] = true;
                    $response["message"] ="Your Password was successfully updated";
                }else{
                    $response["status"] = false;
                    $response["message"] ="Your Password could not be updated";
                }
            }else{
                $response["status"] = false;
                $response["message"] ="Invalid Current Password";
            }
        }
    }else{
        $response["status"] = false;
        $response["message"] ="New password must be the same as confirm new password";
    }


    //}
    
}
else if($type=="blockUser"){
	$userName = trim($_POST["user"]);
	$sql = "update users set status =0 where username = ?";
	$values = array($userName);
		if(pdoExecute($sql, $values)){			
			$response["status"] = true;
			$response["message"] = "The User was successfully Blocked";
		}else{			
			$response["status"] = false;
			$response["message"] = "The User could not be Blocked";
		}
}
else if($type=="activateUser"){
	$userName = trim($_POST["user"]);
	$sql = "update users set status =1 where username = ?";
	$values = array($userName);
		if(pdoExecute($sql, $values)){			
			$response["status"] = true;
			$response["message"] = "The User was successfully Activated";
		}else{			
			$response["status"] = false;
			$response["message"] = "The User could not be Activated";
		}
}
else if($type=="updateinvestments"){
    
    $invNo = $_POST["invNo"];
    $desc = $_POST["desc"];
    $startDate = $_POST["startDate"];
    
    $sql = "update allinvestments set investmentNo ='$invNo' ,description='$desc',startDate='$startDate' where investmentNo = '$invNo'";
    
    $response = array();
    if(mysqli_query($conn, $sql)){
    $response["status"] = true;
        $response["message"] = "Investment details were successfully updated";	
    }else{
        $response["status"] = false;
        $response["message"] = "Investment details could not be updated. Please try again";
    }
}
else if($type=="vehicle"){
	$fleetNumber = mysqli_real_escape_string($conn, trim($_POST["fleetNumber"]));
	$tregNo = mysqli_real_escape_string($conn, trim($_POST["regNo"]));
	$makeCode = mysqli_real_escape_string($conn, trim($_POST["makeCode"]));
	$modelCode = mysqli_real_escape_string($conn, trim($_POST["modelCode"]));
	$vAlias = mysqli_real_escape_string($conn, trim($_POST["vAlias"]));
	$ownerCode = mysqli_real_escape_string($conn, trim($_POST["ownerCode"]));
	$brandCode = mysqli_real_escape_string($conn, trim($_POST["brandCode"]));
	$active = mysqli_real_escape_string($conn, trim($_POST["active"]));
	$photo = $_POST["photo"];
	//check no other vehicle with same regNo
	$sql= "Update `vehicles` set `FleetNumber`='$fleetNumber', `Make`='$makeCode', `Model` = '$modelCode', `Name(alias)`='$vAlias', `Photo`='$photo', `Owner` = '$ownerCode', `brand`='$brandCode', `active`=$active  where RegNo = '$tregNo'";
	if(mysqli_query($conn, $sql)){
		$response["status"] = true;
		$response["message"] = "Vehicle was successfully updated";
	}else{
		$response["status"] = false;
		$response["message"] = "Vehicle could not be updated";
	}
}
else if($type=="numberseries"){
	if(isset($_POST["name"])&&isset($_POST["prefix"])&&isset($_POST["length"])&&isset($_POST["lastNumber"])&&isset($_POST["code"])){
		$name = mysqli_real_escape_string($conn, trim($_POST["name"]));
		$prefix = mysqli_real_escape_string($conn, trim($_POST["prefix"]));
		$length = mysqli_real_escape_string($conn, trim($_POST["length"]));
		$lastNumber = mysqli_real_escape_string($conn, trim($_POST["lastNumber"]));
		$code = mysqli_real_escape_string($conn, trim($_POST["code"]));
		$update = "update numberseries set  name = '$name', prefix='$prefix', length='$length', lastNumberUsed='$lastNumber' where code = '$code'";
		if(mysqli_query($conn,$update)){
			$response["status"] = true;
		$response["message"] ="Number series was successfully updated";
		}
	}
}
else if($type=="employee"){
	$sql = "";
    $fName = mysqli_real_escape_string($conn, trim($_POST["fName"]));	
	$lName = mysqli_real_escape_string($conn, trim($_POST["lName"]));	
	$mName = mysqli_real_escape_string($conn, trim($_POST["mName"]));	
	$idNumber = mysqli_real_escape_string($conn, trim($_POST["idNumber"]));	
	$phoneNumber = mysqli_real_escape_string($conn, trim($_POST["phoneNumber"]));	
	$payrollNumber = mysqli_real_escape_string($conn, trim($_POST["payrollNumber"]));	
	$email = mysqli_real_escape_string($conn, trim($_POST["email"]));	
	$dob = mysqli_real_escape_string($conn, trim($_POST["dob"]));	
	$disabled = mysqli_real_escape_string($conn, trim($_POST["disabled"]));	
	$disabilityDescription = mysqli_real_escape_string($conn, trim($_POST["disabilityDescription"]));	
	$kra = mysqli_real_escape_string($conn, trim($_POST["kra"]));	
	$nssf = mysqli_real_escape_string($conn, trim($_POST["nssf"]));	
	$nhif = mysqli_real_escape_string($conn, trim($_POST["nhif"]));	
	$department = mysqli_real_escape_string($conn, trim($_POST["department"]));	
	$jobTitle = mysqli_real_escape_string($conn, trim($_POST["jobTitle"]));	
	$hod = mysqli_real_escape_string($conn, trim($_POST["hod"]));	
	$employeeNumber = mysqli_real_escape_string($conn, trim($_POST["employeeNumber"]));	
	$gender = mysqli_real_escape_string($conn, trim($_POST["gender"]));	
	$employmentDate = mysqli_real_escape_string($conn, trim($_POST["employmentDate"]));	
	$entitledToLeave = mysqli_real_escape_string($conn, trim($_POST["entitledToLeave"]));	
	$photo = trim($_POST["photo"]);		
	
	$region = isset($_POST["region"])?$_POST["region"]:"";
	$region = mysqli_real_escape_string($conn, trim($region));
	
	$error = false;
	$message = "";
	if($fName==""){
		$message.= $message==""?"":"\n";
		$error = true;
		$message .= "Please specify the employees first name";
	}if($lName==""){
		$error = true;
		$message.= $message==""?"":"\n";
		$message .= "Please specify the employees last name";
	}if($idNumber==""){
		$error = true;
		$message.= $message==""?"":"\n";
		$message .= "Please specify the employees Id Number";
	}if($phoneNumber==""){
		$error = true;
		$message.= $message==""?"":"\n";
		$message .= "Please specify the employees phone Number";
	}
	if($error){
		$response["status"] = false;
		$response["message"] =$message;
	}else{		
		$sql = "update `employee` set `first_name` = '$fName', `middle_name`= '$mName', `last_name`='$lName', `IdNumber`='$idNumber', `payroll_number`= '$payrollNumber', 		`date_of_birth`='$dob', `Pin`='$kra', `PhoneNumber`='$phoneNumber', `Email`='$email', `disabled`=$disabled, `disability_description`='$disabilityDescription', 		`department` = '$department', `job_title`='$jobTitle', `hod`=$hod, `Photo`='$photo', `gender`='$gender',`EmploymentDate`='$employmentDate',`EntitledToLeave`='$entitledToLeave',`region_code` = '$region'	where EmployeeNumber = '$employeeNumber'";
		if(mysqli_query($conn, $sql)){
			if($hod){
			$update = "update employee set hod = 0 where department = $department and hod =1 and not EmployeeNumber = '$employeeNumber'";
			$update2 = "update departments set hod = '$employeeNumber' where code = $department";
			mysqli_query($conn, $update);
			mysqli_query($conn, $update2);
			}
			$response["status"] = true;
			$response["message"] ="The employee was successfully updated";
		}else{
			$response["status"] = false;
			$response["message"] ="The employee could not be updated";
		}
	}
}
else if($type=="disbursementmodes"){
	$id = trim($_POST["id"]);
	$mode = trim($_POST["mode"]);
	$error = false;
	$message = "";
	if(!is_numeric($id)){
		$error = true;
		$message.= "Wrong entry";
	}
	if(strlen($mode)<1){
		$error = true;
		if(strlen($message)>0){
		$message.="\n";
		}
		$message.= "Mode cannot be blank";
		
	}
	if($error){
		$response["status"] = false;
		$response["message"] = $message;
	}else{
		$sql = "";
		$mode = mysqli_real_escape_string($conn, $mode);
		if($id==0){
			$sql = "insert into loandisbursementmodes(id, mode) value ('','$mode')";
		}else{
			$sql = "update loandisbursementmodes set mode = '$mode' where id = $id";
		}
	if(mysqli_query($conn, $sql)){
	$response["status"] = true;
		$response["message"] = "Disbursement mode was successfully updated";	
	}else{
		$response["status"] = false;
		$response["message"] = "Disbursement mode could not be updated. Please try again";
	}
	}
}
else if($type=="generalloanfees"){
	$defaultPenalty = trim($_POST["defaultPenalty"]);
	$withdrawalCharge = $_POST["withdrawalCharge"];
	$balancingCharge = $_POST["balancingCharge"];
	$crb = $_POST["crb"];
	$chequeCommission = $_POST["chequeCommission"];
	$loanForm = $_POST["loanForm"];
	$insurance = $_POST["insurance"];
	$graceperiod = $_POST["graceperiod"];
	$error = false;
	$message = "";

	if(!is_numeric($defaultPenalty)){
	$error = true;
	if(strlen($message)>0){
		$message.="\n";
	}
	$message.="Default penalty must be a numeric figure";
	}

	if(!is_numeric($withdrawalCharge)){
	$error = true;
	if(strlen($message)>0){
		$message.="\n";
	}
	$message.="Withdrawal charge must be a numeric figure";
	}
	if(!is_numeric($graceperiod)){
	$error = true;
	if(strlen($message)>0){
		$message.="\n";
	}
	$message.="Grace Period must be a numeric figure";
	}
	if(!is_numeric($balancingCharge)){
	$error = true;
	if(strlen($message)>0){
		$message.="\n";
	}
	$message.="Balancing charge must be a numeric figure";
	}
	if(!is_numeric($crb)){
	$error = true;
	if(strlen($message)>0){
		$message.="\n";
	}
	$message.="CRB must be a numeric figure";
	}

	if(!is_numeric($chequeCommission)){
	$error = true;
	if(strlen($message)>0){
		$message.="\n";
	}
	$message.="Cheque commission must be a numeric figure";
	}
	if(!is_numeric($loanForm)){
	$error = true;
	if(strlen($message)>0){
		$message.="\n";
	}
	$message.="Loan form must be a numeric figure";
	}


	if($error){
		$response["status"] = false;
		$response["message"] = $message;
	}else{
		$sql = "select * from loangeneralfees where Id = 1";
		$res = mysqli_query($conn, $sql);
		if(mysqli_num_rows($res)>0){
				$sql = "update `loangeneralfees` set  `defaultpenalty` = '$defaultPenalty', `withdrawalcharge`='$withdrawalCharge', `crbcharge`='$crb', `chequecommission` = '$chequeCommission', `loanform` ='$loanForm', `insurance` = '$insurance',`balancingCharge` = '$balancingCharge', `graceperiod` ='$graceperiod'  where Id = 1";
		
	if(mysqli_query($conn, $sql)){
	$response["status"] = true;
		$response["message"] = "General loan fees were successfully updated ";	
	}else{
		$response["status"] = false;
		$response["message"] = "General loan fees could not be updated. Please try again";
	}
		}else{
				$sql = "INSERT INTO `loangeneralfees`(`Id`, `defaultpenalty`, `withdrawalcharge`, `crbcharge`, `chequecommission`, `loanform`, `insurance`,`balancingCharge`,`graceperiod`) VALUES 
		('1','$defaultPenalty','$withdrawalCharge','$crb','$chequeCommission','$loanForm','$insurance','$balancingCharge','$graceperiod')";
		
	if(mysqli_query($conn, $sql)){
	$response["status"] = true;
		$response["message"] = "General loan fees were successfully updated";	
	}else{
		$response["status"] = false;
		$response["message"] = "General loan fees could not be updated. Please try again";
	}
	}

	}
}
else if($type=="guarantors"){
	$guarantorId =mysqli_real_escape_string($conn, trim($_POST["guarantorId"]));
	$memberNumber =mysqli_real_escape_string($conn, trim($_POST["memberNumber"]));
	$loanNumber =mysqli_real_escape_string($conn, trim($_POST["loanNumber"]));
	$percentage =mysqli_real_escape_string($conn, trim($_POST["percentage"]));
	$amountToGuaraantee =mysqli_real_escape_string($conn, trim($_POST["amountToGuaraantee"]));
	$action =mysqli_real_escape_string($conn, trim($_POST["action"]));
	$sql = "";
	if($action=="delete"){
		$sql = "DELETE FROM `loanguarantors` WHERE `id` = '$guarantorId'";	
	}else{
		if($guarantorId==0){
			$sql = "INSERT INTO `loanguarantors`(`id`, `loan`, `member`, `amount_to_guarantee`, `percentage_to_guarantee`) VALUES 
			('','$loanNumber','$memberNumber','$amountToGuaraantee','$percentage')";
		}else{
			$sql = "UPDATE `loanguarantors` SET `loan`='$loanNumber',`member`='$memberNumber',`amount_to_guarantee`='$amountToGuaraantee',`percentage_to_guarantee`='$percentage' WHERE id = '$guarantorId'";
		}
	}
	if(mysqli_query($conn, $sql)){
	$response["status"] = true;
		$response["message"] = "The guarantor was successfully added";	
	}else{
		$response["status"] = false;
		$response["message"] ="The guarantor could not be updated";
	}
}
else if($type=="members"){
	$memberNumber = trim($_POST["memberNumber"]);
	$fName = trim($_POST["fName"]);
	$mName = trim($_POST["mName"]);
	$lName = trim($_POST["lName"]);
	$idNo = trim($_POST["idNo"]);
	$phoneNo = trim($_POST["phoneNo"]);
	$email = trim($_POST["email"]);
	$pin = trim($_POST["pin"]);
	$sql = "update members set FirstName =? ,MiddleName=?,LastName=?,IdNo=?,PhoneNumber=?,Email=?,PIN=? where MemberNo = ? ";
	$values = array($fName,$mName,$lName,$idNo,$phoneNo,$email,$pin,$memberNumber);
	if(pdoExecute($sql, $values)){
		$response["status"] = true;
		$response["message"] = "Member details were successfully updated";	
	}else{
		$response["status"] = false;
		$response["message"] = "Member details could not be updated. Please try again";
	}
}
else if($type=="numberserieslastnumber"){
	if(isset($_POST["code"])&&is_numeric($_POST["code"])&&isset($_POST["lastNumber"])){
		$code = mysqli_real_escape_string($conn, trim($_POST["code"]));
		$lastNumber = mysqli_real_escape_string($conn, trim($_POST["lastNumber"]));
		$update = "UPDATE `numberseries` SET `lastNumberUsed`='$lastNumber' WHERE code ='$code'";
		mysqli_query($conn,$update);
	}
}
else if($type=="memberprofilephoto"){
	$memberNumber = $_POST["memberNumber"];
	$photo = $_POST["photo"];
	$sql = "update members set Photo = ? where MemberNo = ? ";
	$values = array($photo,$memberNumber);
	if(pdoExecute($sql, $values)){
	$response["status"] = true;
		$response["message"] = "Member photo was successfully updated";	
	}else{
		$response["status"] = false;
		$response["message"] = "Member photo could not be updated. Please try again";
	}
}
else if($type=="vendorprofilephoto"){
	$vendorNumber = $_POST["vendorNumber"];
	$photo = $_POST["photo"];
	$sql = "update vendors set vendorImage = ? where vendorNumber = ? ";
	$values = array($photo,$vendorNumber);
	if(pdoExecute($sql, $values)){
	$response["status"] = true;
		$response["message"] = "The vendor photo was successfully updated";	
	}else{
		$response["status"] = false;
		$response["message"] = "The vendor photo could not be updated. Please try again";
	}
}
else if($type=="customerprofilephoto"){
	$customerNumber = $_POST["customerNumber"];
	$photo = $_POST["photo"];
	//file_put_contents("customer.png",base64_decode($photo));
	$sql = "update customers set customerImage = ? where customerNumber = ? ";
	$values = array($photo,$customerNumber);
	if(pdoExecute($sql, $values)){
	$response["status"] = true;
		$response["message"] = "The customer photo was successfully updated";	
	}else{
		$response["status"] = false;
		$response["message"] = "The customer photo could not be updated. Please try again";
	}
}
else if($type=="chartofaccounts"){
	if(isset($_POST["accountNumber"])){
		$accountNumber = mysqli_real_escape_string($conn, trim($_POST["accountNumber"]));
		$currentStatus = mysqli_real_escape_string($conn, trim($_POST["currentStatus"]));
		$newStatus = mysqli_real_escape_string($conn, trim($_POST["newStatus"]));
		$sql = "update chartofaccounts set allowPosting = $newStatus where accountNumber = '$accountNumber' and allowPosting = $currentStatus";
		if(mysqli_query($conn, $sql)){
			$response["status"] = true;
			$response["message"] ="The account was successfully updated";
		}else{
			$response["status"] = false;
			$response["message"] ="The account could not be updated. Please try again later. ";
	}
	}
}
else if($type=="loancollateral"){
	$collateralId =mysqli_real_escape_string($conn, trim($_POST["collateralId"]));
	$regNumber =mysqli_real_escape_string($conn, trim($_POST["regNumber"]));
	$loanNumber =mysqli_real_escape_string($conn, trim($_POST["loanNumber"]));
	$vehicleValue =mysqli_real_escape_string($conn, trim($_POST["vehicleValue"]));
	$logBookReceived =mysqli_real_escape_string($conn, trim($_POST["logBookReceived"]));
	$action =mysqli_real_escape_string($conn, trim($_POST["action"]));
	$sql = "";
	if($action=="delete"){
		$sql = "DELETE FROM `loan_collateral` WHERE `id` = '$collateralId'";	
	}else{
		if($collateralId==0){
			$sql = "INSERT INTO `loan_collateral`(`id`, `loan`, `vehicle_no`, `vehicle_value`, `log_book_received`) VALUES 
			('','$loanNumber','$regNumber','$vehicleValue',$logBookReceived)";
		}else{
			$sql = "UPDATE `loan_collateral` SET `loan`='$loanNumber',`vehicle_no`='$regNumber',`vehicle_value`='$vehicleValue',`log_book_received`=$logBookReceived WHERE id = '$collateralId'";
		}
	}
	if(mysqli_query($conn, $sql)){
	$response["status"] = true;
		$response["message"] = "The collateral was successfully added";	
	}else{
		$response["status"] = false;
		$response["message"] ="The collateral could not be updated";
	}
}
else if($type=="assetdetails"){
	$assetNo = $_POST["assetNo"];
	$Description = $_POST["Description"];
	$serial = $_POST["assetSerial"];
	$date = $_POST["dateAcquired"];
	$location = $_POST["location"];
	$assigned = $_POST["assignedTo"];
	$sql = "UPDATE `fixedassets` SET `Description` = '$Description', `Serial Number`='$serial',
	`Date Acquired`='$date',`Location` ='$location',`Assigned to` ='$assigned' WHERE `No`='$assetNo'";
	if(mysqli_query($conn, $sql)){
		$response["status"] = true;
			$response["message"] = "Asset details were successfully updated";	
		}else{
			$response["status"] = false;
			$response["message"] = "Asset details could not be updated. Please try again";
	   }
}
else if($type=="deactivateemployee"){
	$employeeNo = mysqli_real_escape_string($conn,trim($_POST["employeeNo"]));
	$sql = "select * from employee where EmployeeNumber = '$employeeNo'";
	$res = mysqli_query($conn,$sql);
	if(mysqli_num_rows($res)>0){
		$update = "update employee set exited = 1 where EmployeeNumber = '$employeeNo'";
		if(mysqli_query($conn,$update)){
			$response["status"] = true;
			$response["message"] ="The employee was successfully moved to inactive employees";
		}else{
			$response["status"] = false;
			$response["message"] ="The employee could not be updated";
		}
	}else{
		$response["status"] = false;
		$response["message"] ="The employee could not be found";
	}
}
else if($type=="transactiontype"){
	$transactionCode = trim($_POST["transactionCode"]);
	$transactionDescription = trim($_POST["transactionDescription"]);
	$accountNo = trim($_POST["accountNo"]);
	$enabled = trim($_POST["enabled"]);
	$showOnReceipt = trim($_POST["showOnReceipt"]);
	$showOnAgency = trim($_POST["showOnAgency"]);
	$journalAccountType = trim($_POST["journalAccountType"]);
	$tTransactionCode = mysqli_real_escape_string($conn, $transactionCode);
	$check = "select * from transactiontypes where Code = '$tTransactionCode'";
	$checkRes = mysqli_query($conn,$check);
	if(mysqli_num_rows($checkRes)<1){
		$response["status"] = false;
		$response["message"] = "A transaction type with the entered code does not exist";
	}else{
		$sql = "update transactiontypes set `Description` = ?,`GLAccount` = ?,`enabled` = ?,`receipt`=?,`journalAccountType`= ?,`agency`= ? where `Code` = ?";
		$values = array($transactionDescription,$accountNo,$enabled,$showOnReceipt,$journalAccountType,$showOnAgency,$transactionCode);
		if(pdoExecute($sql,$values)){
			$response["status"] = true;
			$response["message"] = "The transaction type was successfully updated";
		}else{
			$response["status"] = false;
			$response["message"] = "The transaction type could not be updated";
		}
	}
	
}
else if($type=="vendor"){
	$vendorNumber = trim($_POST["vendorNumber"]);
	$fName = trim($_POST["fName"]);
	$mName = trim($_POST["mName"]);
	$lName = trim($_POST["lName"]);
	$idNo = trim($_POST["idNo"]);
	$phoneNo = trim($_POST["phoneNo"]);
	$email = trim($_POST["email"]);
	$pin = trim($_POST["pin"]);
	$dob = trim($_POST["dob"]);
	$gender = trim($_POST["gender"]);
	$bankName = trim($_POST["bankName"]);
	$bankBranch = trim($_POST["bankBranch"]);
	$branchCode = trim($_POST["branchCode"]);
	$bankAccountNo = trim($_POST["bankAccountNo"]);
	$postingGroup = trim($_POST["postingGroup"]);
    $region = trim($_POST["region"]);

	
	//check vendor exists
	$tVendorNo = mysqli_real_escape_string($conn, $vendorNumber);
	$sql = "SELECT * FROM `vendors` where vendorNumber = '$tVendorNo'";
	$res = mysqli_query($conn, $sql);
	if(mysqli_num_rows($res)<1){ //update
		$response["status"] = false;
		$response["message"] = "A vendor with the entered vendor number does not exist";
		
	}else{ //insert
		$sql = "update `vendors` set `firstName` =?,`middleName`=?,`lastName`=?,`idNo`=?, `kraPin`=?, `dateofbirth`=?, `phoneNumber`=?, `email`=?,   `vendorpostinggroup`=?, `bankName`=?, `bankBranch`=?, `branchCode`=?,`bankAccountNo`=?,`gender`=?,`regionCode`=? where `vendorNumber` = ?";
		$values = array($fName,$mName,$lName,$idNo,$pin, $dob, $phoneNo,$email,$postingGroup,$bankName,$bankBranch,$branchCode,$bankAccountNo,$gender,$region,$vendorNumber);
		if(pdoExecute($sql, $values)){
			$response["status"] = true;
			$response["message"] = "The vendor was successfully updated";
		}else{
			$response["status"] = false;
			$response["message"] = "The vendor could not be updated";
		}
	}
}
else if($type=="customer"){
	if(isset($_POST["fName"])&&isset($_POST["lName"])&&isset($_POST["idNo"])&&isset($_POST["phoneNo"])&&isset($_POST["customerNo"])){
	    $custNo = mysqli_real_escape_string($conn, trim($_POST["customerNo"]));
	    $checkExists = "select * from customers where customerNumber = '$custNo'";
		$checkRes = mysqli_query($conn,$checkExists );
		if(mysqli_num_rows($checkRes)<1){
			$response["status"] = false;
			$response["message"] = "A customer with the selected customer No does not exists";
		}else{		
			$sql= "update `customers` set `firstName`=?,`middleName`=?,`lastName`=?, `idNo`=?,  `kraPin`=?,`dateofbirth`=?, `phoneNumber`=?, `gender`=?, `email`=?, `customerpostinggroup`=?, `salesAgent`=?,`region`=? where `customerNumber` = ?";
			$values = array();
			$dob = trim($_POST["dateOfBirth"]);
			if(strlen($dob)<1){
				$dob = null;
			}
			$salesAgent = "";
			if(isset($_POST["accountNo"])){
			    $salesAgent = trim($_POST["accountNo"]);
			}
			$region = "";
			if(isset($_POST["region"])){
			    $region = trim($_POST["region"]);
			}
			
			$values[0] = trim($_POST["fName"]);
			$values[1] = trim($_POST["mName"]);
			$values[2] = trim($_POST["lName"]);
			$values[3] = trim($_POST["idNo"]);
			$values[4] = trim($_POST["kraPin"]);
			$values[5] = $dob;
			$values[6] = trim($_POST["phoneNo"]);
			$values[7] = trim($_POST["gender"]);
			$values[8] = trim($_POST["email"]);
			$values[9] = trim($_POST["postingGroup"]);
			$values[10] = $salesAgent;
			$values[11] = $region;
			$values[12] = $custNo;
			if(pdoExecute($sql,$values)){
			    $response["status"] = true;
				$response["message"] = "The customer was successfully updated";
			}else{
				$response["status"] = false;
				$response["message"] = "The customer could not be updated. Please try again";
			}
		}
	} else {
		$response["status"] = false;
		$response["message"] = "Please fill all mandatory fields";
	}

}
else if($type=='payrollemployees'){
	$employeeNumber = mysqli_real_escape_string($conn, trim($_POST["employeeNumber"]));	
	$bank = "";
	$bankBranch = "";
	$bankAccount = "";
	$basicSalary = 0;
	$paysPAYE = 0;
	$paysNHIF = 0;
	$paysNSSF = 0;
	$suspendPay = 0;	
	if(isset($_POST["bank"])){
		$bank = mysqli_real_escape_string($conn, trim($_POST["bank"]));
	}if(isset($_POST["bankBranch"])){
		$bankBranch = mysqli_real_escape_string($conn, trim($_POST["bankBranch"]));
	}if(isset($_POST["bankAccount"])){
		$bankAccount = mysqli_real_escape_string($conn, trim($_POST["bankAccount"]));
	}if(isset($_POST["basicSalary"])){
		$basicSalary = mysqli_real_escape_string($conn, trim($_POST["basicSalary"]));
	}if(isset($_POST["paysPAYE"])){
		$paysPAYE = mysqli_real_escape_string($conn, trim($_POST["paysPAYE"]));
	}if(isset($_POST["paysNHIF"])){
		$paysNHIF = mysqli_real_escape_string($conn, trim($_POST["paysNHIF"]));
	}if(isset($_POST["paysNSSF"])){
		$paysNSSF = mysqli_real_escape_string($conn, trim($_POST["paysNSSF"]));
	}if(isset($_POST["suspendPay"])){
		$suspendPay = mysqli_real_escape_string($conn, trim($_POST["suspendPay"]));
	}
	
	$error = false;
	$message = "";
	/*if($fName==""){
		$message.= $message==""?"":"\n";
		$error = true;
		$message .= "Please specify the employees first name";
	}if($lName==""){
		$error = true;
		$message.= $message==""?"":"\n";
		$message .= "Please specify the employees last name";
	}if($idNumber==""){
		$error = true;
		$message.= $message==""?"":"\n";
		$message .= "Please specify the employees Id Number";
	}if($phoneNumber==""){
		$error = true;
		$message.= $message==""?"":"\n";
		$message .= "Please specify the employees phone Number";
	}*/
	if($error){
		$response["status"] = false;
		$response["message"] =$message;
	}else{
		
		$sql = "update `employee` set `Bank`= '$bank',`BankBranch`= '$bankBranch',`AccountNumber`= '$bankAccount',`BasicSalary`= '$basicSalary',`PaysPaye`= '$paysPAYE',`paysNHIF`= '$paysNHIF',`paysNSSF`= '$paysNSSF',`suspendPay`= '$suspendPay'		where EmployeeNumber = '$employeeNumber'";
		if(mysqli_query($conn, $sql)){
			$response["status"] = true;
			$response["message"] ="The employee was successfully updated";
		}else{
			$response["status"] = false;
			$response["message"] ="The employee could not be updated";
		}
	}
}

else if ($type=="dashboardmatrix"){
    $moduleId = mysqli_real_escape_string($conn,trim($_POST["moduleId"]));
    $roleId = mysqli_real_escape_string($conn,trim($_POST["roleId"]));
    $status = mysqli_real_escape_string($conn,trim($_POST["status"]));
    //get all possible rights for the role, add them to table if not exist
    //assign all of them to view yes
    $check = "SELECT A.*,(SELECT COUNT(id) FROM `dashboardmatrix` WHERE submoduleid =A.id and roleId ='$roleId' )total FROM `submodules` A where A.enabled = 1 and A.moduleId = '$moduleId'";
    $checkRes = mysqli_query($conn,$check);
    $insertSql = "";
    $valuesArray = array();
    while($checkResult = mysqli_fetch_assoc($checkRes)){
        $total =$checkResult["total"] ;
        $subModule = $checkResult["id"];
        if($total==0){
            $insertSql.=strlen($insertSql)==0?",":"";
            $insertSql.="(?,?,?)";
            array_push($valuesArray,$roleId);
            array_push($valuesArray,$subModule);
            array_push($valuesArray,0);
        }
    }
    if(strlen($insertSql)>0){
            $insertSql = "INSERT INTO `dashboardmatrix`(`roleId`, `submoduleid`, `view`) VALUES $insertSql";
            pdoExecute($insertSql,$valuesArray);
    }
    $sql = "update dashboardmatrix set view = ? where roleId=? and submoduleid in (SELECT id FROM `submodules` WHERE moduleId = ?) ";
    $values = array($status,$roleId,$moduleId);
    if(pdoExecute($sql, $values)){
        $response["status"] =true;
        $response["message"] ="The rights were successfully updated";
    }else{
        $response["status"] =false;
        $response["message"] ="The rights could not be updated";
    }
    
}
elseif ($type=="glaccount"){
	if(isset($_POST["accountNumber"])){
	    $accountNumber = mysqli_real_escape_string($conn, trim($_POST["accountNumber"]));
		$accountName = mysqli_real_escape_string($conn, trim($_POST["accountName"]));
		
		$accountType = mysqli_real_escape_string($conn, trim($_POST["accountType"]));
		$accountCategory = mysqli_real_escape_string($conn, trim($_POST["accountCategory"]));
		$accountSubCategory = mysqli_real_escape_string($conn, trim($_POST["accountSubCategory"]));
		$accountGroup = mysqli_real_escape_string($conn, trim($_POST["accountGroup"]));
		$accountCurrency = mysqli_real_escape_string($conn, trim($_POST["accountCurrency"]));
		
		//check exists
		$checkSql = "select * from chartofaccounts where accountNumber = ?";
		$checkValues = array($accountNumber);
		$checkResults = fetchWithPdo($checkSql, $checkValues);
		if(count($checkResults)==0){
		    $response["status"] = false;
    		$response["message"] ="A GL account with the selected account number does not exists";
		}else if(count($checkResults)>1){
		    $response["status"] = false;
    		$response["message"] ="A GL account with the selected account number does not exists";
		}else{
    		$sql = "update `chartofaccounts` set `account_type` = ?, `account_category` =?, `account_sub_category`=?, `account_group`=?,`accountName`=?, `currency` =? where `accountNumber` = ?";
    		$values = array($accountType,$accountCategory,$accountSubCategory,$accountGroup,$accountName,$accountCurrency,$accountNumber);
    			if(pdoExecute($sql,$values)){
    				$response["status"] = true;
    				$response["message"] ="The Account was successfully updated";
    			}else{
    				$response["status"] = false;
    				$response["message"] ="The account could not be updated";
    			}
		}
	}
}
elseif ($type=="customerlocation"){
    $customerNo = trim($_POST["customerNo"]);
    $latitude = trim($_POST["latitude"]);
    $longitude = trim($_POST["longitude"]);
    $placeName = trim($_POST["placeName"]);
    $sql = "UPDATE `customers` SET `location`=?,`location_latitude`=?,`location_longitude`=? WHERE `customerNumber`=?";
    $values = array($placeName,$latitude,$longitude,$customerNo);
     if(pdoExecute($sql, $values)){
        $response["status"] =true;
        $response["message"] ="The customer was successfully updated";
    }else{
        $response["status"] =false;
        $response["message"] ="The customer could not be updated";
    }
    
}
else if($type=="salesline"){
    if(isset($_POST["headerNo"])&&isset($_POST["itemNo"])&&isset($_POST["itemType"])&&isset($_POST["documentType"])&&isset($_POST["lineId"])){
        $headerNo = trim($_POST["headerNo"]);
        $itemType = trim($_POST["itemType"]);
        $itemNo = trim($_POST["itemNo"]);
        $documentType = trim($_POST["documentType"]);
        $lineId = trim($_POST["lineId"]);
        
        
        
        $closingStock = isset($_POST["closingStock"])?trim($_POST["closingStock"]):0;
        $returnToWarehouse = isset($_POST["returnToWarehouse"])?trim($_POST["returnToWarehouse"]):0;
        
        $description = isset($_POST["description"])?trim($_POST["description"]):"";
        $unitOfMeasure = isset($_POST["unitOfMeasure"])?trim($_POST["unitOfMeasure"]):0;
        $details = isset($_POST["details"])?trim($_POST["details"]):"";
        $unitPrice = isset($_POST["unitPrice"])?trim($_POST["unitPrice"]):0;
        $requestedQuantity = isset($_POST["requestedQuantity"])?trim($_POST["requestedQuantity"]):0;
        $issuedQuantity = isset($_POST["issuedQuantity"])?trim($_POST["issuedQuantity"]):0;
        $quantity = isset($_POST["quantity"])?trim($_POST["quantity"]):0;
        $freeIssues = isset($_POST["freeIssues"])?trim($_POST["freeIssues"]):0;
        
        
        $taxPercentage = 0;
        $docType = fetchWithPdo("SELECT * FROM `document_types` WHERE code= ?",array($documentType));
        $header = fetchWithPdo("SELECT A.*,B.pricing_group customerPricingGroup,D.pricing_group vsmPricingGroup FROM `sales_header` A LEFT JOIN customers B on A.customer = B.customerNumber LEFT JOIN shopLocations C on A.source_location = C.id LEFT JOIN users D on A.createdBy = D.username WHERE A.doc_no=? ",array($headerNo));
        if(count($header)!=1){ 
            $response["status"] = false;
		    $response["message"] ="The document could not be found";
        }else if(!($header[0]["status"]=="Draft"||$header[0]["status"]=="Pending")){
            $response["status"] = false;
		    $response["message"] ="The document is no longer open for editing";
        }else if(count($docType)<1){
            $response["status"] = false;
		    $response["message"] ="Unknown Document Type";
        }else{
            $getDocument = fetchWithPdo("SELECT * FROM `sales_header` WHERE doc_no = ? and document_type = ?",array($headerNo,$documentType));
            if(count($getDocument)<1){
                $response["status"] = false;
		        $response["message"] ="The ".$docType[0]["document_type"]." could not be found";
            }else{
                if($getDocument[0]["posted"]){
                    $response["status"] = false;
		            $response["message"] ="The ".$docType[0]["document_type"]." has alredy been posted";
                }else{
                    $hasError = false;
                    if($itemType=="Services"){
                        $service = fetchWithPdo("SELECT * FROM `chargeitems` WHERE id= ?",array($itemNo));
                        if(count($service)<1){
                            $hasError = true;
                            $response["status"] = false;
		                    $response["message"] ="The service could not be found";
                        }else{
                            $myService = $service[0];
                            $unitPrice = $unitPrice==0?$myService["default_amount"]:$unitPrice;
                            $taxPercentage = $myService["tax_rate"];
                            $description=strlen($description)<1?$myService["description"]:$description;
                        }
                        
                    }else if($itemType=="Items"){
                        $item = fetchWithPdo("SELECT A.code,A.name,A.description, B.percentage taxPercentage,A.unitOfMeasure,A.price FROM `items` A LEFT JOIN taxGroups B on A.taxGroup = B.code WHERE A.code = ?",array($itemNo));
                        if(count($item)<1){
                            $hasError = true;
                            $response["status"] = false;
		                    $response["message"] ="The product could not be found";
                        }else{
                            $myItem = $item[0];
                            $unitPrice = $unitPrice==0?$myItem["price"]:$unitPrice;
                            if($documentType=="EndofDay"||$documentType=="StockRequest"||$documentType=="WarehouseReturn"){  
                                $unitPrice=getProductPrice($itemNo,$header[0]["vsmPricingGroup"]);
                            }else{
                                $unitPrice=getProductPrice($itemNo,$header[0]["customerPricingGroup"]);
                            }
                             
                            
                            $taxPercentage = $myItem["taxPercentage"];
                            $description=strlen($description)<1?$myItem["name"]:$description;
                        }
                    }else{
                        $hasError = true;
                        $response["status"] = false;
		                $response["message"] ="Unknown Item Type";
                    }
                    if(!$hasError){
                        $totalAmount = $unitPrice*$quantity;
                        $totalVAT = ($totalAmount*$taxPercentage)/(100+$taxPercentage);
                        $totalExclVAT = $totalAmount -$totalVAT; 
                        $sql = "update `sales_lines` set  `itemType`=?, `itemNo`=?, `description`=?, `unitOfMeasureCode`=?, `details`=?, `unitPrice`=?, `requested_quantity`=?, `issued_quantity`=?,`warehouse_return`=?,`free_issues`=?,`closing_stock`=?, `quantity`=?, `totalExclVAT`=?, `totalVAT`=?, `totalAmount`=? where `lineId`=? and  `header_no`=? and  `document_type`=? ";
                        $values = array($itemType,$itemNo,$description,$unitOfMeasure,$details,$unitPrice,$requestedQuantity,$issuedQuantity,$returnToWarehouse,$freeIssues,$closingStock,$quantity,$totalExclVAT,$totalVAT,$totalAmount,$lineId,$headerNo,$documentType);
                        if(pdoExecute($sql,$values)){
                            $response["status"] = true;
		                    $response["message"] ="The ".$docType[0]["document_type"]." line was successfully updated";
                        }else{
                            $response["status"] = false;
		                    $response["message"] ="The ".$docType[0]["document_type"]." line could not be updated";
                        }
                    }
                }
            }
        }
    }else{
        $response["status"] = false;
		$response["message"] ="Some mandatory fields could not be found. Please contact Support";
    }
    
    
}
else if($type=="sendapprovalentry"){
    $recordType = trim($_POST["recordType"]);
    if($recordType=="salesheader"){
        $docNo = trim($_POST["docNo"]);
        $sql = "update sales_header set status = ? where doc_no=? and status= ?";
        $values = array("Pending",$docNo,"Draft");
         if(pdoExecute($sql, $values)){
            $response["status"] =true;
            $response["message"] ="The record was successfully sent for approval";
        }else{
            $response["status"] =false;
            $response["message"] ="The approval request could not be captured";
        }
        
    }
}else if($type=="expresssaleline"){
	$lineId = trim($_POST["lineId"]);
	$quantity = trim($_POST["quantity"]);
	$getItem = "SELECT A.*,B.posted,C.price,D.percentage FROM `expresssalelines` A LEFT JOIN expressSales B on A.saleCode = B.code LEFT JOIN items C on A.item = C.code LEFT JOIN taxGroups D on C.taxGroup =D.code WHERE A.id= ?";
	$res = fetchWithPdo($getItem,array($lineId));
	if(!(count($res)==1)){
		$response["status"] = false;
		$response["message"] ="The sales line does not exist";
	}else{
		$posted = $res[0]["posted"];
		if($posted){
			$response["status"] = false;
			$response["message"] ="The receipt has already been posted";
		}else{

			$update ="UPDATE `expresssalelines` SET `unitPrice`=?,`quantity`=?,`totalExclVAT`=?,`totalVAT`=?,`totalAmount`=? WHERE `id`=? ";
			$unitPrice = $res[0]["price"];
			$percentage = $res[0]["percentage"];///100;
			$totalAmount = $unitPrice*$quantity;
			$totalVAT = Round((($totalAmount/(100+$percentage))*$percentage),2);
			$totalExcl = $totalAmount-$totalVAT;
			
			$values = array($unitPrice,$quantity,$totalExcl,$totalVAT,$totalAmount,$lineId);
			if(pdoExecute($update,$values)){
				$response["status"] = true;
				$response["message"] ="The line was successfully updated";
			}else{
				$response["status"] = false;
				$response["message"] ="The line could not be updated";
			}
		}

		
	}
}
else if($type=="salespayments"){
    $headerNo = trim($_POST["headerNo"]);
    $paymentMethodId = trim($_POST["paymentMethodId"]);
    $amount = isset($_POST["amount"])?trim($_POST["amount"]):0;
    
    
      
    if(isset($_POST["customer"])){
        $customer = trim($_POST["customer"]);
        $invoiceNo = trim($_POST["invoiceNo"]);
        $insert = pdoExecute("INSERT INTO `daily_report_payments`(`report_id`, `payment_method`,`customer_code`,`invoice_no`, `amount`) VALUES (?,?,?,?,?)",array($headerNo,$paymentMethodId,$customer,$invoiceNo,$amount));
        if($insert){
            $response["status"] = true;
		    $response["message"] ="The payment was successfully added";
        }else{
            $response["status"] = false;
		    $response["message"] ="The payment could not be added";
        }
        
    }else if(isset($_POST["customerName"])){
        $customerName = trim($_POST["customerName"]);
        $product = trim($_POST["product"]);
        $quantity = trim($_POST["quantity"]); 
        //get foregone amount
        $originalProductCode = getFreeVersionCode($product);
        $originalProduct = fetchWithPdo("SELECT price FROM `items` WHERE code = ?",array($originalProductCode));
        if(count($originalProduct)==1){
            $amount = $originalProduct[0]["price"]*$quantity;
            $sql = "INSERT INTO `daily_report_payments`(`report_id`, `payment_method`,  `customer_name`, `amount`, `product_code`, `quantity`) VALUES (?,?,?,?,?,?)";
            $values = array($headerNo,$paymentMethodId,$customerName,$amount,$product,$quantity);
            if(pdoExecute($sql,$values)){
                $response["status"] = true;
		        $response["message"] ="The payment was successfully added";
            }else{
                $response["status"] = false;
		        $response["message"] ="The payment could not be added";
            }
            
        }else{
            $response["status"] = false;
		    $response["message"] ="The non free version of the product does not exit";
        }
         
        
        
    }
    else if(isset($_POST["discountCustomer"])){
        $customer = trim($_POST["discountCustomer"]);
        $product = trim($_POST["product"]);
        $quantity = trim($_POST["quantity"]); 
        
        $vsm = fetchWithPdo("SELECT * FROM users WHERE username = (SELECT createdBy from sales_header WHERE sales_header.doc_no = ?)",array($headerNo));
        $vsmPricingGroup = $vsm[0]["pricing_group"];
        $myCustomer = fetchWithPdo("SELECT * from customers WHERE customerNumber = ?",array($customer));
        $customerPricingGroup = $myCustomer[0]["pricing_group"];
        $normalPrice = getProductPrice($product,$vsmPricingGroup);
        $discountedPrice = getProductPrice($product,$customerPricingGroup);
        
        $sellingPrice = $discountedPrice*$quantity;
        $discount = ($normalPrice*$quantity)-$sellingPrice;
        
        //
        //get normal price
        //get special cutomer price
        //add discount
        
        //
        
        $sql = "INSERT INTO `daily_report_payments`(`report_id`, `payment_method`, `customer_code`, `amount`, `product_code`, `quantity`, `discount`) VALUES (?,?,?,?,?,?,?)";
        $values = array($headerNo,$paymentMethodId,$customer,$sellingPrice,$product,$quantity,$discount);
        if(pdoExecute($sql,$values)){
            $response["status"] = true;
		       $response["message"] ="The payment was successfully added";
        }else{
            $response["status"] = false;
		       $response["message"] ="The payment could not be added";
        }
            
       
         
        
        
    }
    else{
    $check = fetchWithPdo("SELECT * FROM `daily_report_payments` WHERE `report_id`=? and `payment_method`= ?",array($headerNo,$paymentMethodId));
    if(count($check)==0){
        $insert = pdoExecute("INSERT INTO `daily_report_payments`(`report_id`, `payment_method`, `amount`) VALUES (?,?,?)",array($headerNo,$paymentMethodId,$amount));
        if($insert){
            $response["status"] = true;
		    $response["message"] ="The payment was successfully added";
        }else{
            $response["status"] = false;
		    $response["message"] ="The payment could not be added";
        }
        
    }else if(count($check)==1){
        $updated = pdoExecute("update `daily_report_payments`  set `amount`=? where `report_id`=? and  `payment_method`=? ",array($amount,$headerNo,$paymentMethodId));
        if($updated){
            $response["status"] = true;
		    $response["message"] ="The payment was successfully updated";
        }else{
            $response["status"] = false;
		    $response["message"] ="The payment could not be updated";
        }
    }
    }
}

  
//  $postFiels = "customerNo={$customerid}&&latitude={$latitude}&&longitude={$longitude}&&placeName={$placeName}";
//  $feedback = loadFromServer("masterupdate?type=customerlocation",$postFiels, $_SESSION["userName"], $_SESSION["password"]);

echo json_encode($response);