<?php
include("functions.php");
$baseUrl= "https://www.kisajushops.kuzasystems.com/sync?shop=kagio&&key=sdfghjk123456";
$startDate = "";
$sync = fetchWithPdo("SELECT MAX(`date`) lastSync FROM `sales_sync`",array());
if(count($sync)>0){
	$startDate = $sync[0]["lastSync"];
}else{
	$firstSale = fetchWithPdo("SELECT MIN(dateCreated) firstSale FROM `expressSales` WHERE posted = 1",array());
	if(count($firstSale)>0){
		$startDate = $firstSale[0]["firstSale"];
	}
}
if(strlen($startDate)>0){
	$start    = new DateTime($startDate);
	$end      = (new DateTime())->modify('-1 day');
	$interval = DateInterval::createFromDateString('1 day');
	$period   = new DatePeriod($start, $interval, $end);
	foreach ($period as $dt) {//monthly transfers section
	    $date = $dt->format('Y-m-d');
		$salesSql = "SELECT B.postedOn, A.item, A.unitPrice,SUM(A.quantity) totalQuantity FROM `expresssalelines` A LEFT JOIN expressSales B on A.saleCode = B.code WHERE B.posted = 1 and B.postedOn = ? GROUP by A.item,A.unitPrice; ";
		$sales = fetchWithPdo($salesSql,array($date));
		$paymentsSql = "SELECT A.bank_code,ROUND(SUM(A.amount),2) totalAmount FROM `express_sale_payments` A LEFT JOIN expresssales B on A.sales_code = B.code WHERE B.posted = 1 and B.postedOn = ? GROUP by A.bank_code; ";
		$payments = fetchWithPdo($paymentsSql,array($date));
		$mySales =  json_encode($sales);
		$myPayments =  json_encode($payments);
		echo "Am here";
		$ch = curl_init();
  		curl_setopt($ch, CURLOPT_URL, $baseUrl."&type=sales");
  		curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
  		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  		curl_setopt($ch, CURLOPT_HEADER, FALSE);

  		curl_setopt($ch, CURLOPT_POST, TRUE);

  		curl_setopt($ch, CURLOPT_POSTFIELDS, 
		   "date=".$date
		  ."&sales=".$mySales
  		  ."&payments=".$myPayments
  		);
  		curl_setopt($ch, CURLOPT_HTTPHEADER, array(
  		  "Content-Type: application/x-www-form-urlencoded"
  		));
  		$tResponse = curl_exec($ch);
		  $response = json_decode($tResponse);
		  if($response["status"]){
			$values= array($response["salesDate"]);
			$sql ="INSERT INTO `sales_sync`( `date`, `sync_on`) VALUES (?,NOW())";
			pdoExecute($sql,$values);
		  }

		  
	}
}
